<?php


namespace Schaffen\Core\Person\Repositories;

use Freelabois\LaravelQuickstart\Extendables\Repository;
use Schaffen\Core\Person\Models\Person;

class PersonRepository extends Repository
{
    protected $model = Person::class;
    protected $orderBy = 'pes_nome';

    protected $searchableFields = [
        ["field" => 'pes_status'],
        ["field" => 'pes_identificador'],
    ];

    public function injectFiltersOnQuery()
    {
        $serial = null;
        $precisa_de_usuario = null;
        $name = null;
        extract($this->filters);

        $this->query->when($name, function ($query) use ($name){
            return $query->where('pes_nome', 'ilike', '%'.$name.'%');
        });

        $this->query->when($serial, function ($query) use ($serial) {
            return $query->whereHas('employee.mobile', function ($query) use ($serial) {
                return $query->where('fum_serial', $serial)
                    ->whereNull('fum_bloqueado')
                    ->where('fum_libera_manutencao', 1);
            });
        });

        $this->query->when($precisa_de_usuario, function ($query) {
            return $query->whereHas('users');
        });
        parent::injectFiltersOnQuery();
    }
}
